/* misc.h - definitions of misc functions */
/*
 *  PUPA  --  Preliminary Universal Programming Architecture for GRUB
 *  Copyright (C) 2002 Yoshinori K. Okuji <okuji@enbug.org>
 *
 *  PUPA is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with PUPA; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "misc.h"

/* XXX: this is for Unix.  */
#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>

void
pupa_error (const char *fmt, ...)
{
  va_list ap;
  
  va_start (ap, fmt);
  vprintf (fmt, ap);
  va_end (ap);
  putchar ('\n');
  exit (1);
}

void *
pupa_memcpy (void *dest, const void *src, unsigned n)
{
  return memcpy (dest, src, n);
}

int
pupa_printf (const char *fmt, ...)
{
  va_list ap;
  int ret;
  
  va_start (ap, fmt);
  ret = vprintf (fmt, ap);
  va_end (ap);

  return ret;
}  
