/* test.c - mm test */
/*
 *  PUPA  --  Preliminary Universal Programming Architecture for GRUB
 *  Copyright (C) 2002 Yoshinori K. Okuji <okuji@enbug.org>
 *
 *  PUPA is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with PUPA; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "mm.h"
#include <stdlib.h>
#include <assert.h>

#define DUMP() pupa_mm_dump (__LINE__)

#define REGION_SIZE	0x10000

int
main (void)
{
  void *r[3];
  unsigned i;
  void *p[5];
  
  for (i = 0; i < sizeof (r) / sizeof (r[0]); i++)
    {
      r[i] = malloc (REGION_SIZE);
      assert (r[i]);
      pupa_mm_init_region (r[i], REGION_SIZE);
    }

  DUMP ();

  p[0] = pupa_malloc (100);
  assert (p[0]);
  DUMP ();
  
  p[1] = pupa_malloc (10);
  assert (p[1]);
  DUMP ();
  
  p[2] = pupa_malloc (1000);
  assert (p[2]);
  DUMP ();
  
  p[3] = pupa_malloc (100);
  assert (p[3]);
  DUMP ();

  p[4] = pupa_memalign (0x1000, 256);
  assert (p[4]);
  DUMP ();
  
  pupa_free (p[2]);
  DUMP ();

  pupa_free (p[1]);
  DUMP ();

  pupa_free (p[0]);
  DUMP ();

  pupa_free (p[4]);
  DUMP ();
  
  for (i = 0; i < sizeof (r) / sizeof (r[0]); i++)
    free (r[i]);

  return 0;
}
